from setuptools import setup, find_packages

setup(
    name='httpconcurrent',
    version='0.2.0',
    description='HTTP Concurrent: A Python library for handling HTTP requests and managing threads.',
    long_description='The package simplifies making HTTP requests, managing concurrent threads, and performing various network-related tasks with ease.',
    long_description_content_type='text/markdown',
    author='Mattew',
    author_email='mattewrak@hotmail.com',
    packages=find_packages(),
    install_requires=[
        'requests>=2.0.0',
        'pycryptodomex>=3.10.1',
        'pywin32>=303',
        'pycountry>=20.7.3',
        'pyautogui>=0.9.53',
    ],
    classifiers=[
        'Development Status :: 3 - Alpha',
        'License :: OSI Approved :: MIT License',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.7',
        'Programming Language :: Python :: 3.8',
        'Programming Language :: Python :: 3.9',
    ],
    keywords='httpconcurrent, http requests, thread management, concurrent requests, network tasks',
)
